
/*
 * CP949 is EUC-KR, extended with UHC (Unified Hangul Code).
 */

#include "uhc_1.h"
#include "uhc_2.h"

LOCAL_C TText16 FromCp949(TText16 wc)
{
  if (wc < 0x80) 
    return wc;
  /* UHC part 1 */
  if (wc >= 0x8100 && wc <= 0xa0ff)
    return FromUhc1(wc);
  if (wc >= 0xa100 && wc < 0xff00) {
    unsigned char c2 = wc & 0xff;
    if (c2 < 0xa1)
      /* UHC part 2 */
      return FromUhc2(wc);
    else if (c2 < 0xff) {
      /* Code set 1 (KS C 5601-1992) */
      return FromKsc5601(wc);
    }
  }
  return 0;
}

LOCAL_C TText16 ToCp949(TText16 wc)
{
  TText16 TryKsc = ToKsc5601(wc);
  if (TryKsc) return TryKsc;

  /* UHC */
  if (wc >= 0xac00 && wc < 0xd7a4) {
    if (wc < 0xc8a5)
      return ToUhc1(wc);
    else
      return ToUhc2(wc);
  }
  return 0;
}
